Index: tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/preferences/ChartsEnginePreferencePage.java
===================================================================
--- tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/preferences/ChartsEnginePreferencePage.java	(revision 2719)
+++ tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/preferences/ChartsEnginePreferencePage.java	(revision 2720)
@@ -28,23 +28,23 @@
  *
  */
 public class ChartsEnginePreferencePage extends TXMPreferencePage {
-
+	
 	/**
 	 * The charts engine selection combo box.
 	 */
 	private ComboFieldEditor chartsEngineSelectionComboField;
-
+	
 	/**
 	 * The charts engine export formats selection combo box.
 	 */
 	private ComboFieldEditor chartsEngineExportFormatsComboField;
-
+	
 	protected boolean charsEngineHasChanged = false;
 	
-
+	
 	@Override
 	protected void createFieldEditors() {
-
+		
 		// Charts engine selection
 		String chartsEngines[][] = new String[ChartsEnginesManager.getInstance().size()][2];
 		
@@ -60,49 +60,49 @@
 		
 		
 		// FIXME: SJ: test to select the chart engine order rather than a exclusive one since the engines are not exclusive anymore, eg. some to create charts and other to create graphs
-//		ListEditor listEditor = new ListEditor(ChartsEnginePreferences.CHARTS_ENGINES_ORDER, "Ordre de préférence des moteurs", this.getFieldEditorParent()) {
-//			
-//			@Override
-//			protected String[] parseString(String enginesOrder) {
-//				return ChartsEnginePreferences.getEnginesOrder(enginesOrder);
-//			}
-//			
-//			@Override
-//			protected String getNewInputObject() {
-////				InputDialog dialog = new InputDialog(getShell(), "New Buildconfiguration", "Enter the name of the Buildconfiguration to add", "", null);
-////				if (dialog.open() == InputDialog.OK) {
-////					return dialog.getValue();
-////				}
-//				return null;
-//			}
-//			
-//			@Override
-//			protected String createList(String[] engineNames) {
-//				return ChartsEnginePreferences.createEnginesOrder(engineNames);
-//			}
-//		};
-//	
-//		// default initialization
-//		if(!TXMPreferences.keyExists("/" + InstanceScope.SCOPE +"/" + ChartsEnginePreferences.getInstance().getPreferencesNodeQualifier(), ChartsEnginePreferences.CHARTS_ENGINES_ORDER))	{
-//			ChartsEnginePreferences.getInstance().put(ChartsEnginePreferences.CHARTS_ENGINES_ORDER, ChartsEnginesManager.getInstance().createEnginesOrder());
-//		}
-//		
-//		listEditor.setPreferenceName(ChartsEnginePreferences.CHARTS_ENGINES_ORDER);
-//		listEditor.load();
-//		
-//		// hide the "New" and "Remove" buttons
-//		listEditor.getButtonBoxControl(this.getFieldEditorParent()).getChildren()[0].setVisible(false);;
-//		listEditor.getButtonBoxControl(this.getFieldEditorParent()).getChildren()[1].setVisible(false);
-//
-//	    this.addField(listEditor);
+		// ListEditor listEditor = new ListEditor(ChartsEnginePreferences.CHARTS_ENGINES_ORDER, "Ordre de préférence des moteurs", this.getFieldEditorParent()) {
+		//
+		// @Override
+		// protected String[] parseString(String enginesOrder) {
+		// return ChartsEnginePreferences.getEnginesOrder(enginesOrder);
+		// }
+		//
+		// @Override
+		// protected String getNewInputObject() {
+		//// InputDialog dialog = new InputDialog(getShell(), "New Buildconfiguration", "Enter the name of the Buildconfiguration to add", "", null);
+		//// if (dialog.open() == InputDialog.OK) {
+		//// return dialog.getValue();
+		//// }
+		// return null;
+		// }
+		//
+		// @Override
+		// protected String createList(String[] engineNames) {
+		// return ChartsEnginePreferences.createEnginesOrder(engineNames);
+		// }
+		// };
+		//
+		// // default initialization
+		// if(!TXMPreferences.keyExists("/" + InstanceScope.SCOPE +"/" + ChartsEnginePreferences.getInstance().getPreferencesNodeQualifier(), ChartsEnginePreferences.CHARTS_ENGINES_ORDER)) {
+		// ChartsEnginePreferences.getInstance().put(ChartsEnginePreferences.CHARTS_ENGINES_ORDER, ChartsEnginesManager.getInstance().createEnginesOrder());
+		// }
+		//
+		// listEditor.setPreferenceName(ChartsEnginePreferences.CHARTS_ENGINES_ORDER);
+		// listEditor.load();
+		//
+		// // hide the "New" and "Remove" buttons
+		// listEditor.getButtonBoxControl(this.getFieldEditorParent()).getChildren()[0].setVisible(false);;
+		// listEditor.getButtonBoxControl(this.getFieldEditorParent()).getChildren()[1].setVisible(false);
+		//
+		// this.addField(listEditor);
 		
-	    
-	    
-	    
+		
+		
+		
 		// current engine supported export formats
-	    this.createExportFormatComboField(ChartsEnginesManager.getInstance().getCurrentEngine());
-
-
+		this.createExportFormatComboField(ChartsEnginesManager.getInstance().getCurrentEngine());
+		
+		
 		// other shared preferences
 		SWTChartsComponentsProvider.createChartsRenderingPreferencesFields(this, this.getFieldEditorParent());
 		
@@ -112,9 +112,9 @@
 		FontFieldEditor font = new FontFieldEditor(ChartsEnginePreferences.FONT, "Font", "Specificities / Spécificités / Специфичность", this.getFieldEditorParent()); //$NON-NLS-1$ //$NON-NLS-2$
 		this.addField(font);
 		// FIXME: preview area tests
-		//font.fillIntoGrid(this.getFieldEditorParent(), 4);
-		//((Text)font.getPreviewControl()).setLayoutData(new GridData(GridData.FILL_BOTH));
-		//System.out.println("ChartsEnginePreferencePage.createFieldEditors() " + font.getPreviewControl());
+		// font.fillIntoGrid(this.getFieldEditorParent(), 4);
+		// ((Text)font.getPreviewControl()).setLayoutData(new GridData(GridData.FILL_BOTH));
+		// System.out.println("ChartsEnginePreferencePage.createFieldEditors() " + font.getPreviewControl());
 		
 		
 	}
@@ -124,8 +124,9 @@
 	 * 
 	 * @param engine
 	 */
-	protected void createExportFormatComboField(ChartsEngine engine)	{
-		this.chartsEngineExportFormatsComboField = new ComboFieldEditor(ChartsEnginePreferences.DEFAULT_EXPORT_FORMAT, ChartsUIMessages.defaultExportFormat, ChartsEnginesManager.getExportFormatsEntryNamesAndValues(engine), this.getFieldEditorParent());
+	protected void createExportFormatComboField(ChartsEngine engine) {
+		this.chartsEngineExportFormatsComboField = new ComboFieldEditor(ChartsEnginePreferences.DEFAULT_EXPORT_FORMAT, ChartsUIMessages.defaultExportFormat, ChartsEnginesManager
+				.getExportFormatsEntryNamesAndValues(engine), this.getFieldEditorParent());
 		this.addField(this.chartsEngineExportFormatsComboField);
 	}
 	
@@ -133,49 +134,49 @@
 	@Override
 	public void propertyChange(PropertyChangeEvent event) {
 		super.propertyChange(event);
-
+		
 		// FIXME: SJ: test to try to update the Export formats combo box when changing of current charts engine
 		// NOTE: SJ: warning, event.getProperty() seems bugged and does not return the correct property name but the string "field_value_editor"
-		if(event.getSource() == this.chartsEngineSelectionComboField && !event.getNewValue().equals(event.getOldValue()))	{
+		if (event.getSource() == this.chartsEngineSelectionComboField && !event.getNewValue().equals(event.getOldValue())) {
 			this.charsEngineHasChanged = true;
-//			this.chartsEngineExportFormatsComboField.dispose();
-//			this.createExportFormatComboField(ChartsEnginesManager.getInstance().getEngine((String) event.getNewValue()));
-//			this.adjustGridLayout();
-//			this.getFieldEditorParent().layout();
+			// this.chartsEngineExportFormatsComboField.dispose();
+			// this.createExportFormatComboField(ChartsEnginesManager.getInstance().getEngine((String) event.getNewValue()));
+			// this.adjustGridLayout();
+			// this.getFieldEditorParent().layout();
 		}
 		
 	}
 	
-
 	
+	
 	@Override
 	public void init(IWorkbench workbench) {
 		this.setPreferenceStore(new TXMPreferenceStore(ChartsEnginePreferences.getInstance().getPreferencesNodeQualifier()));
 		this.setDescription(ChartsUIMessages.thesePreferencesWillApplyToNewChartsPreviouslyCreatedChartsWillNotBeAffected);
 	}
-
+	
 	@Override
 	public boolean performOk() {
-			
+		
 		super.performOk();
-
 		
+		
 		// Set the new monochrome color for all charts engine theme
-		for(int i = 0; i < ChartsEngine.getChartsEngines().size(); i++) {
-			ChartsEngine.getChartsEngines().get(i).getTheme().setMonochromeColor(ChartsEnginePreferences.getInstance().getString(ChartsEnginePreferences.MONOCHROME_COLOR));
+		for (ChartsEngine engine : ChartsEnginesManager.getChartsEngines()) {
+			engine.getTheme().setMonochromeColor(ChartsEnginePreferences.getInstance().getString(ChartsEnginePreferences.MONOCHROME_COLOR));
 		}
 		
 		Log.info(ChartsUIMessages.recreatingChartsEngineAndSWTChartComponentsProvider);
-
+		
 		ChartsEnginesManager.getInstance().setCurrentEngine(this.getPreferenceStore().getString(ChartsEnginePreferences.CURRENT_NAME));
 		
 		// Sets the new current charts SWT component provider according to the new current charts engine
 		SWTChartsComponentsProvider.setCurrrentComponentsProvider(ChartsEnginesManager.getInstance().getCurrentEngine());
 		
 		// Reset the default export format to the new current charts engine first supported export file format
-		//ChartsEnginePreferences.getInstance().put(ChartsEnginePreferences.DEFAULT_EXPORT_FORMAT, ChartsEngine.getCurrent().getSupportedOutputFileFormats().get(0));
-			
-
+		// ChartsEnginePreferences.getInstance().put(ChartsEnginePreferences.DEFAULT_EXPORT_FORMAT, ChartsEngine.getCurrent().getSupportedOutputFileFormats().get(0));
+		
+		
 		return true;
 	}
-}
\ No newline at end of file
+}
Index: tmp/org.txm.chartsengine.r.core/src/org/txm/chartsengine/r/core/RChartCreator.java
===================================================================
--- tmp/org.txm.chartsengine.r.core/src/org/txm/chartsengine/r/core/RChartCreator.java	(revision 2719)
+++ tmp/org.txm.chartsengine.r.core/src/org/txm/chartsengine/r/core/RChartCreator.java	(revision 2720)
@@ -12,35 +12,43 @@
 
 /**
  * R base chart creator.
+ * 
+ * Currently the R chart creator can't update a chart. It is always recreated in the updateChart method
+ * 
+ * An empty file is created in the createChart method
+ * 
  * @author sjacquot
  *
  */
-public abstract class RChartCreator extends ChartCreator {
-
+public abstract class RChartCreator<R extends ChartResult> extends ChartCreator<RChartsEngine, R> {
 	
-	
+	/**
+	 * creates an empty file. the chart will be written after in the updateChart method
+	 */
 	@Override
-	public Object createChart(ChartResult result) {
-		//return this.createChartFile(result);
-		// FIXME: SJ: tests. No need to return the chart now? it will be done in updateChart()
-		return null;
+	public Object createChart(R result) {
+		return this.getChartsEngine().createTmpFile(this.getFileNamePrefix()); 
 	}
-
 	
-	@Override
-	public void updateChart(ChartResult result) {
+	/**
+	 * Effectively writes the R chart in the given file
+	 * 
+	 * @param result
+	 * @param file the file to write. not null
+	 * @return
+	 */
+	public abstract File createChart(R result, File file);
 	
+	@Override
+	public void updateChart(R result) {
+		
 		Object chart = result.getChart();
-
-		// creates a new chart but using the same file
-		// FIXME: SJ to MD: this case should never happen, if it happens then a bug must fixed at another location
-		// TODO: find the bug then just keep: this.createChartFile(result, (File)chart);
-		if (chart instanceof File) {
-			this.createChartFile(result, (File)chart);
+		
+		if (chart instanceof File) { // The RChartCreators can't update a chart -> the chart is always recreated
+			createChart(result, (File) chart);
 		}
-		// creates a new chart using a new file
 		else {
-			result.setChart(this.createChartFile(result));
+			Log.warning("Error: R chart was null in: " + result);
 		}
 	}
 	
@@ -49,21 +57,9 @@
 		Log.severe(this.getClass() + ".getSeriesShapesColors(): Not yet implemented."); //$NON-NLS-1$
 		return null;
 	}
-
-
 	
 	@Override
-	public Class getChartsEngineClass() {
+	public Class<RChartsEngine> getChartsEngineClass() {
 		return RChartsEngine.class;
 	}
-	
-	/**
-	 * Convenience method.
-	 * @return the casted charts engine.
-	 */
-	protected RChartsEngine getChartsEngine() {
-		return (RChartsEngine) this.chartsEngine;
-	}
-
-	
 }
Index: tmp/org.txm.textsbalance.core/src/org/txm/textsbalance/core/chartsengine/jfreechart/JFCTextsBalanceSpiderChartCreator.java
===================================================================
--- tmp/org.txm.textsbalance.core/src/org/txm/textsbalance/core/chartsengine/jfreechart/JFCTextsBalanceSpiderChartCreator.java	(revision 2719)
+++ tmp/org.txm.textsbalance.core/src/org/txm/textsbalance/core/chartsengine/jfreechart/JFCTextsBalanceSpiderChartCreator.java	(revision 2720)
@@ -14,41 +14,42 @@
 import org.txm.textsbalance.core.functions.TextsBalance;
 
 public class JFCTextsBalanceSpiderChartCreator extends JFCChartCreator {
-
-
+	
+	
 	@Override
 	public JFreeChart createChart(ChartResult result) {
-
+		
 		TextsBalance textsBalance = (TextsBalance) result;
 		JFreeChart chart = null;
-
+		
 		// Creates an empty dataset
 		HashMap<Integer, Comparable[]> data = textsBalance.getDataset();
 		DefaultCategoryDataset dataset = new DefaultCategoryDataset();
 		
 		SpiderWebPlot plot = new SpiderWebPlot(dataset);
 		plot.setToolTipGenerator(new CategoryToolTipGenerator() {
+			
 			@Override
 			public String generateToolTip(CategoryDataset dataset, int row, int col) {
 				// FIXME: tests
-//				System.out.println("JFCBalanceSpiderChartCreator.createChart(...).new CategoryToolTipGenerator() {...}.generateToolTip() row = " + row + " col = " + col);
-//				System.out.println("JFCBalanceSpiderChartCreator.createChart(...).new CategoryToolTipGenerator() {...}.generateToolTip() " + dataset.getValue(row, col));
+				// System.out.println("JFCBalanceSpiderChartCreator.createChart(...).new CategoryToolTipGenerator() {...}.generateToolTip() row = " + row + " col = " + col);
+				// System.out.println("JFCBalanceSpiderChartCreator.createChart(...).new CategoryToolTipGenerator() {...}.generateToolTip() " + dataset.getValue(row, col));
 				
-//				if(balance.getValues().size() > col)	{
-//					 balance.getValues().get(col);
-//				}
-//				return "error";
+				// if(balance.getValues().size() > col) {
+				// balance.getValues().get(col);
+				// }
+				// return "error";
 				return String.valueOf(dataset.getValue(row, col).intValue());
 			}
 		});
-
-
+		
+		
 		chart = new JFreeChart(plot);
 		
 		return chart;
 	}
-
-
+	
+	
 	@Override
 	public void updateChart(ChartResult result) {
 		
@@ -58,10 +59,10 @@
 		
 		// freeze rendering while computing
 		chart.setNotify(false);
-
+		
 		// updating data set
 		HashMap<Integer, Comparable[]> data = textsBalance.getDataset();
-		DefaultCategoryDataset dataset = (DefaultCategoryDataset) ((SpiderWebPlot)chart.getPlot()).getDataset();
+		DefaultCategoryDataset dataset = (DefaultCategoryDataset) ((SpiderWebPlot) chart.getPlot()).getDataset();
 		dataset.clear();
 		
 		Set<Integer> keys = data.keySet();
@@ -73,7 +74,8 @@
 			dataset.addValue(key, value[0], value[1]);
 		}
 		
-		chart.setTitle("metadata = " + textsBalance.getStructuralUnitProperty() + ", N = " +  textsBalance.getValues().size() + ", fmin = " + textsBalance.getFMin() + ", fmax = " + textsBalance.getFMax() + ", group by texts = " + textsBalance.groupingByTexts());
+		chart.setTitle("metadata = " + textsBalance.getStructuralUnitProperty() + ", N = " + textsBalance.getValues().size() + ", fmin = " + textsBalance.getFMin() + ", fmax = " + textsBalance
+				.getFMax() + ", group by texts = " + textsBalance.groupingByTexts());
 		
 		super.updateChart(result);
 	}
@@ -82,11 +84,11 @@
 	public Class getResultDataClass() {
 		return TextsBalance.class;
 	}
-
-
-
-
-
 	
-
+	
+	
+	
+	
+	
+	
 }
Index: tmp/org.txm.textsbalance.core/src/org/txm/textsbalance/core/chartsengine/r/RBalanceSpiderChartCreator.java
===================================================================
--- tmp/org.txm.textsbalance.core/src/org/txm/textsbalance/core/chartsengine/r/RBalanceSpiderChartCreator.java	(revision 2719)
+++ tmp/org.txm.textsbalance.core/src/org/txm/textsbalance/core/chartsengine/r/RBalanceSpiderChartCreator.java	(revision 2720)
@@ -2,9 +2,7 @@
 
 import java.io.File;
 
-import org.txm.chartsengine.core.results.ChartResult;
 import org.txm.chartsengine.r.core.RChartCreator;
-import org.txm.chartsengine.r.core.RChartsEngine;
 import org.txm.textsbalance.core.functions.TextsBalance;
 
 /**
@@ -12,78 +10,66 @@
  * @author sjacquot
  *
  */
-public class RBalanceSpiderChartCreator extends RChartCreator {
-
-
+public class RBalanceSpiderChartCreator extends RChartCreator<TextsBalance> {
+	
+	
 	@Override
-	public File createChartFile(ChartResult result, File file) {
+	public File createChart(TextsBalance result, File file) {
 		
-//		try {
-	
-			
-//			RWorkspace rw = RWorkspace.getRWorkspaceInstance();
-//	System.out.println("load wordcloud...");
-//			rw.eval("library(wordcloud)"); //$NON-NLS-1$
-			//System.out.println("tmpfreqs...");
-//			rw.addVectorToWorkspace("tmpfreqs", wordCloud.getFreqs()); //$NON-NLS-1$
-			//System.out.println("tmplabels...");
-//			rw.addVectorToWorkspace("tmplabels", wordCloud.getLabels()); //$NON-NLS-1$
-			
-			//wordcloud(words,freq,
-			// scale : A vector of length 2 indicating the range of the size of the words.
-			// min.freq:  words with frequency below min.freq will not be plotted
-			// max.words : Maximum number of words to be plotted. least frequent terms dropped
-			// random.order : plot words in random order. If false, they will be plotted in decreasing frequency
-			// random.color : choose colors randomly from the colors. If false, the color is chosen based on the frequency
-			// rot.per : proportion words with 90 degree rotation
-			// colors : color words from least to most frequent
-			// ordered.colors : if true, then colors are assigned to words in order
-			//System.out.println("wordcloud...");
-			
-			// FIXME : stars plot tests
-			//String cmd = "stars(mtcars[, 1:7], key.loc = c(14, 2), main = \"Motor Trend Cars : stars(*, full = F)\", full = FALSE)"; //$NON-NLS-1$
-			String cmd = "stars(USJudgeRatings, locations = c(0, 0), scale = FALSE, radius  =  FALSE, col.stars = 1:10, key.loc = c(0, 0), main = \"US Judges rated\")";
-			//String cmd = "stars(cbind(1:16, 10*(16:1)), draw.segments = TRUE, main = \"A Joke -- do *not* use symbols on 2D data!\")";
-			
-			
-
-			//rw.plot(file, cmd, ((RChartsEngine) this.chartsEngine).getRDevice());
-			
-			((RChartsEngine) this.chartsEngine).plot(file, cmd);
-			
-				//System.out.println("cleaning");
-//				rw.eval("rm(tmplabels)"); //$NON-NLS-1$
-//				rw.eval("rm(tmpfreqs)"); //$NON-NLS-1$
-//		}
-//		catch(RWorkspaceException e) {
-//			// TODO Auto-generated catch block
-//			e.printStackTrace();
-//		}
-//		catch(REXPMismatchException e) {
-//			// TODO Auto-generated catch block
-//			e.printStackTrace();
-//		}
-//		catch(StatException e) {
-//			// TODO Auto-generated catch block
-//			e.printStackTrace();
-//		}
+		// try {
 		
+		
+		// RWorkspace rw = RWorkspace.getRWorkspaceInstance();
+		// System.out.println("load wordcloud...");
+		// rw.eval("library(wordcloud)"); //$NON-NLS-1$
+		// System.out.println("tmpfreqs...");
+		// rw.addVectorToWorkspace("tmpfreqs", wordCloud.getFreqs()); //$NON-NLS-1$
+		// System.out.println("tmplabels...");
+		// rw.addVectorToWorkspace("tmplabels", wordCloud.getLabels()); //$NON-NLS-1$
+		
+		// wordcloud(words,freq,
+		// scale : A vector of length 2 indicating the range of the size of the words.
+		// min.freq: words with frequency below min.freq will not be plotted
+		// max.words : Maximum number of words to be plotted. least frequent terms dropped
+		// random.order : plot words in random order. If false, they will be plotted in decreasing frequency
+		// random.color : choose colors randomly from the colors. If false, the color is chosen based on the frequency
+		// rot.per : proportion words with 90 degree rotation
+		// colors : color words from least to most frequent
+		// ordered.colors : if true, then colors are assigned to words in order
+		// System.out.println("wordcloud...");
+		
+		// FIXME : stars plot tests
+		// String cmd = "stars(mtcars[, 1:7], key.loc = c(14, 2), main = \"Motor Trend Cars : stars(*, full = F)\", full = FALSE)"; //$NON-NLS-1$
+		String cmd = "stars(USJudgeRatings, locations = c(0, 0), scale = FALSE, radius  =  FALSE, col.stars = 1:10, key.loc = c(0, 0), main = \"US Judges rated\")";
+		// String cmd = "stars(cbind(1:16, 10*(16:1)), draw.segments = TRUE, main = \"A Joke -- do *not* use symbols on 2D data!\")";
+		
+		
+		
+		// rw.plot(file, cmd, ((RChartsEngine) this.chartsEngine).getRDevice());
+		this.chartsEngine.plot(file, cmd);
+		
+		// System.out.println("cleaning");
+		// rw.eval("rm(tmplabels)"); //$NON-NLS-1$
+		// rw.eval("rm(tmpfreqs)"); //$NON-NLS-1$
+		// }
+		// catch(RWorkspaceException e) {
+		// // TODO Auto-generated catch block
+		// e.printStackTrace();
+		// }
+		// catch(REXPMismatchException e) {
+		// // TODO Auto-generated catch block
+		// e.printStackTrace();
+		// }
+		// catch(StatException e) {
+		// // TODO Auto-generated catch block
+		// e.printStackTrace();
+		// }
+		
 		return file;
 	}
-
 	
-
-	// FIXME: to not load the chart creator, to remove when implemented
 	@Override
-	public Class getChartsEngineClass() {
-		return null;
-	}
-	
-	@Override
-	public Class getResultDataClass() {
+	public Class<TextsBalance> getResultDataClass() {
 		return TextsBalance.class;
 	}
-
-
-
 }
Index: tmp/org.txm.ahc.core/src/org/txm/ahc/core/chartsengine/r/RAHCChartCreator.java
===================================================================
--- tmp/org.txm.ahc.core/src/org/txm/ahc/core/chartsengine/r/RAHCChartCreator.java	(revision 2719)
+++ tmp/org.txm.ahc.core/src/org/txm/ahc/core/chartsengine/r/RAHCChartCreator.java	(revision 2720)
@@ -3,7 +3,6 @@
 import java.io.File;
 
 import org.txm.ahc.core.functions.AHC;
-import org.txm.chartsengine.core.results.ChartResult;
 import org.txm.chartsengine.r.core.RChartCreator;
 
 /**
@@ -13,13 +12,12 @@
  * @author sjacquot
  *
  */
-public class RAHCChartCreator extends RChartCreator {
+public class RAHCChartCreator extends RChartCreator<AHC> {
 	
-	
 	@Override
-	public File createChartFile(ChartResult result, File file) {
+	public File createChart(AHC result, File file) {
 		
-		AHC ahc = (AHC) result;
+		AHC ahc = result;
 		
 		String cmd = null;
 		// 2D
@@ -43,10 +41,7 @@
 	
 	
 	@Override
-	public Class getResultDataClass() {
+	public Class<AHC> getResultDataClass() {
 		return AHC.class;
 	}
-	
-	
-	
 }
Index: tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/ChartCreator.java
===================================================================
--- tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/ChartCreator.java	(revision 2719)
+++ tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/ChartCreator.java	(revision 2720)
@@ -2,35 +2,31 @@
 
 import java.awt.Color;
 import java.io.File;
+import java.lang.reflect.Field;
 import java.util.ArrayList;
-
 import org.txm.chartsengine.core.results.ChartResult;
-import org.txm.core.results.TXMResult;
 import org.txm.utils.logger.Log;
 
 
-
 /**
  * Abstract base for chart creation in command plug-ins from a result data.
  * 
  * @author sjacquot
  *
  */
-public abstract class ChartCreator {
-
+public abstract class ChartCreator<T extends ChartsEngine, R extends ChartResult> {
 	
 	public final static String extensionPointId = "org.txm.chartsengine.chartcreator"; //$NON-NLS-1$
-
 	
 	/**
 	 * Basic commands constants for chart updating.
 	 */
-	public static final int SHOW_TITLE = 0, SHOW_LEGEND = 1; 
+	public static final int SHOW_TITLE = 0, SHOW_LEGEND = 1;
 	
 	/**
 	 * The linked charts engine.
 	 */
-	protected ChartsEngine chartsEngine;
+	protected T chartsEngine;
 	
 	/**
 	 * The prefix that will be added to the generated file name.
@@ -42,91 +38,61 @@
 	 */
 	protected String chartType;
 	
-	
-	
 	/**
 	 * Default constructor.
 	 */
-	public ChartCreator() {
-	}
-
+	public ChartCreator() {}
 	
+	
 	/**
 	 * Sets the linked charts engine.
+	 * 
 	 * @param chartsEngine
 	 */
-	public void setChartsEngine(ChartsEngine chartsEngine)	{
+	public void setChartsEngine(T chartsEngine) {
 		this.chartsEngine = chartsEngine;
 	}
 	
-	
 	/**
 	 * Creates a chart object according to the specified result data.
+	 * 
 	 * @param result
 	 * @return
 	 */
-	public abstract Object createChart(ChartResult result);
+	public abstract Object createChart(R result);
 	
-	
 	/**
-	 * Creates a chart file according to the specified result data and parameters.
-	 * @param result
-	 * @param file
-	 * @return
-	 */
-	public File createChartFile(ChartResult result, File file)	{
-		Object chart = this.createChart(result);
-		// FIXME: SJ: became useless?
-		// Synchronizes the chart with the shared preferences as show title, show legend, rendering colors mode, etc. 
-		//this.updateChart(result);
-		return this.chartsEngine.createChartFile(chart, file);
-	}
-	
-	/**
-	 * Creates a chart file according to the specified result data using the specified prefix for the file name.
-	 * @param result
-	 * @param fileNamePrefix
-	 * @return
-	 */
-	public File createChartFile(ChartResult result, String fileNamePrefix)	{
-		return this.createChartFile(result, this.chartsEngine.createTmpFile(fileNamePrefix));
-	}
-	
-
-	/**
-	 * Creates a chart file according to the specified result data.
-	 * @param result
-	 * @return
-	 */
-	public File createChartFile(ChartResult result) {
-		return this.createChartFile(result, this.fileNamePrefix);
-	}
-
-	/**
 	 * Updates an existing chart.
 	 * By default this method does nothing.
 	 * Subclasses should override this method to update a chart without recreating one.
 	 * This method is dedicated for example, to hide a title, to change a rendering style, etc.
 	 * This method is called by the SWT charts components provider when just after a chart is created.
+	 * 
 	 * @param result
 	 * @param preferencesNode
 	 */
-	public void updateChart(ChartResult result)	{
+	public void updateChart(R result) {
 		Log.severe("ChartCreator.updateChart(): not implemented. This method is intended to be overridden in subclasses."); //$NON-NLS-1$
 	}
 	
 	/**
 	 * Gets the type of the result data linked with this chart creator.
+	 * 
 	 * @return
 	 */
-	public abstract Class getResultDataClass();
-
+	public abstract Class<? extends R> getResultDataClass();
+	
+	public abstract Class<? extends T> getChartsEngineClass();
+	
 	/**
-	 * Gets the type of the charts engine with this chart creator.
-	 * @return
+	 * Convenience method.
+	 * 
+	 * @return the casted charts engine.
 	 */
-	public abstract Class getChartsEngineClass();
-
+	protected T getChartsEngine() {
+		return this.chartsEngine;
+	}
+	
 	/**
 	 * @param fileNamePrefix the fileNamePrefix to set
 	 */
@@ -136,29 +102,27 @@
 	
 	/**
 	 * Gets the color used to draw the shapes of the series.
+	 * 
 	 * @param chart
 	 * @param index
 	 * @return
 	 */
 	public abstract ArrayList<Color> getSeriesShapesColors(Object chart);
-
-
+	
 	/**
 	 * @return the fileNamePrefix
 	 */
 	public String getFileNamePrefix() {
 		return fileNamePrefix;
 	}
-
-
+	
 	/**
 	 * @return the chartType
 	 */
 	public String getChartType() {
 		return chartType;
 	}
-
-
+	
 	/**
 	 * @param chartType the chartType to set
 	 */
Index: tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/results/ChartResult.java
===================================================================
--- tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/results/ChartResult.java	(revision 2719)
+++ tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/results/ChartResult.java	(revision 2720)
@@ -8,6 +8,7 @@
 
 import org.txm.chartsengine.core.ChartCreator;
 import org.txm.chartsengine.core.ChartsEngine;
+import org.txm.chartsengine.core.ChartsEnginesManager;
 import org.txm.chartsengine.core.preferences.ChartsEnginePreferences;
 import org.txm.core.results.Parameter;
 import org.txm.core.results.TXMResult;
@@ -272,21 +273,19 @@
 		
 		// try to find a chart creator in other charts engines
 		if (chartCreator == null) {
-			for (int i = 0; i < ChartsEngine.getChartsEngines().size(); i++) {
-				ChartsEngine chartsEngine = ChartsEngine.getChartsEngines().get(i);
-				if (chartsEngine == this.chartsEngine) {
-					continue;
+			for (ChartsEngine alternativeEngine : ChartsEnginesManager.getChartsEngines()) {
+				if (alternativeEngine == this.chartsEngine) {
+					continue; // not an alternative
 				}
-				chartCreator = chartsEngine.getChartCreator(this);
+				chartCreator = alternativeEngine.getChartCreator(this);
 				if (chartCreator != null) {
-					Log.finest("ChartResult.renderChart(): another suitable chart creator has been found in charts engine: " + chartsEngine + "."); //$NON-NLS-1$
-					this.chartsEngine = chartsEngine;
+					Log.finest("ChartResult.renderChart(): another suitable chart creator has been found in charts engine: " + alternativeEngine + "."); //$NON-NLS-1$
+					this.chartsEngine = alternativeEngine;
 					break;
 				}
 			}
 		}
 		
-		
 		if (chartCreator != null) {
 			
 			// FIXME: fix #1
Index: tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/ChartsEnginesManager.java
===================================================================
--- tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/ChartsEnginesManager.java	(revision 2719)
+++ tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/ChartsEnginesManager.java	(revision 2720)
@@ -2,6 +2,7 @@
 
 import java.util.ArrayList;
 import java.util.Arrays;
+import java.util.HashMap;
 import java.util.Map;
 import java.util.TreeSet;
 
@@ -23,6 +24,14 @@
  */
 public class ChartsEnginesManager extends EnginesManager<ChartsEngine> {
 	
+	private static final long serialVersionUID = 2369327408978181063L;
+	
+	/**
+	 * Installed charts engines.
+	 * TODO remove this static member and use the ChartsEnginesManager
+	 */
+	protected static ArrayList<ChartsEngine> chartsEngines;
+	
 	@Override
 	public boolean fetchEngines() {
 		return this.fetchEngines(ChartsEngine.EXTENSION_POINT_ID);
@@ -34,12 +43,12 @@
 		// FIXME: temporary solution to not break the charts engines but later need to stop to use
 		// ChartsEngine.chartsEngines, ChartsEngine.currentChartsEngineIndex, getCurrent() etc.
 		// and directly manage that in the Manager
-		ChartsEngine.chartsEngines = new ArrayList<>();
+		chartsEngines = new ArrayList<>();
 		// ChartsEngine.currentChartsEngineIndex = 0;
 		//
 		
 		for (ChartsEngine engine : this.values()) {
-			ChartsEngine.chartsEngines.add(engine);
+			chartsEngines.add(engine);
 		}
 		
 		// add the engines sorted by order defined in preferences
@@ -133,9 +142,9 @@
 	public ChartsEngine getChartsEngine(String outputFormat) {
 		
 		ChartsEngine chartsEngine = null;
-		for (int i = 0; i < ChartsEngine.chartsEngines.size(); i++) {
+		for (int i = 0; i < chartsEngines.size(); i++) {
 			
-			ChartsEngine tmpChartsEngine = ChartsEngine.chartsEngines.get(i);
+			ChartsEngine tmpChartsEngine = chartsEngines.get(i);
 			
 			// checking display formats
 			ArrayList<String> displayFormats = tmpChartsEngine.getSupportedOutputDisplayFormats();
@@ -216,4 +225,12 @@
 		return EngineType.CHARTS;
 	}
 	
+	/**
+	 * Returns the installed charts engine contributions.
+	 * 
+	 * @return
+	 */
+	public static ArrayList<ChartsEngine> getChartsEngines() {
+		return chartsEngines;
+	}
 }
